#include <GUIConstantsEx.au3>
#include <EditConstants.au3>
#include <FileConstants.au3>
#include <MsgBoxConstants.au3>
#include <Constants.au3>
#include <StringConstants.au3>



GUICreate( "FLIR E4 Firmware 1.21.0 / 1.22.0 .cfc-Generator", 530, 540 )

GUICtrlCreateLabel( "This tool uses the previous work of many many smart people from the EEVblog Forum Community." & @CRLF & _
	"It's just an easy to use GUI for previously made tools." & @CRLF & _
	"If you haven't already, please have a look:", 10, 10 )

$cForum = GUICtrlCreateButton( "Open EEVblog Forum E4 teardown thread", 10, 50 )


GUICtrlCreateLabel( "Step 1:", 10, 90 )
$cInputFile = GUICtrlCreateButton( "Select input *.cfc file", 50, 85 )

GUICtrlCreateLabel( "Selected file:", 50, 120 )
$cInputFilePath = GUICtrlCreateInput( "None selected yet", 115, 117, 400, 20, $ES_READONLY + $ES_AUTOHSCROLL )


GUICtrlCreateLabel( "Step 2:", 10, 170 )
$cDecryptFile = GUICtrlCreateButton( "Decrypt input *.cfc file and save as conf_plain.cfg", 50, 165 )
GUICtrlSetState( $cDecryptFile, $GUI_DISABLE )

GUICtrlCreateLabel( "SUID from input file:", 50, 200 )
$cSUID = GUICtrlCreateInput( "Not decrypted yet", 190, 197, 140, 20, $ES_READONLY )

GUICtrlCreateLabel( "Serial number from input file:", 50, 220 )
$cSerialNumber = GUICtrlCreateInput( "Not decrypted yet", 190, 217, 90, 20, $ES_READONLY )


GUICtrlCreateLabel( "Step 3:", 10, 270 )
$cCreateNewFile = GUICtrlCreateButton( "Create conf_new.cfg based on conf_template.cfg with serial number from above", 50, 265 )
GUICtrlSetState( $cCreateNewFile, $GUI_DISABLE )


GUICtrlCreateLabel( "Step 4:", 10, 320 )
$cCalcCRC03 = GUICtrlCreateButton( "Calculate CRC03 for conf_new.cfg file", 50, 315 )
GUICtrlSetState( $cCalcCRC03, $GUI_DISABLE )

GUICtrlCreateLabel( "Calculated CRC03:", 50, 350 )
$cCRC03 = GUICtrlCreateInput( "Not calculated yet", 145, 348, 95, 20, $ES_READONLY )


GUICtrlCreateLabel( "Step 5:", 10, 400 )
$cAddCRC03 = GUICtrlCreateButton( "Add CRC03 from above to conf_new.cfg", 50, 395 )
GUICtrlSetState( $cAddCRC03, $GUI_DISABLE )


GUICtrlCreateLabel( "Step 6:", 10, 450 )
$cEncryptFile = GUICtrlCreateButton( "Encrypt conf_new.cfg with SUID from above and save as conf_new.cfc", 50, 445 )
GUICtrlSetState( $cEncryptFile, $GUI_DISABLE )


GUICtrlCreateLabel( "Step 7:", 10, 500 )
$cOpenExplorer = GUICtrlCreateButton( "Open Explorer and select generated conf_new.cfc", 50, 495 )
GUICtrlSetState( $cOpenExplorer, $GUI_DISABLE )


GUISetState( @SW_SHOW )



Local $iMsg = 0

While True
	$iMsg = GUIGetMsg()

	Switch $iMsg
		Case $cForum
			ShellExecute( "http://www.eevblog.com/forum/testgear/flir-e4-thermal-imaging-camera-teardown/" )



		Case $cInputFile
			$sInputFilePath = FileOpenDialog( "Select input file", @ScriptDir, "Config File Crypted (*.cfc)|All Files (*.*)", $FD_FILEMUSTEXIST )
			If @ERROR Then
				ContinueLoop
			EndIf

			GUICtrlSetData( $cInputFilePath, $sInputFilePath )
			GUICtrlSetState( $cInputFile, $GUI_DISABLE )
			GUICtrlSetState( $cDecryptFile, $GUI_ENABLE )



		Case $cDecryptFile
			If FileExists( @ScriptDir & "\conf_plain.cfg" ) Then
				MsgBox( $MB_OK + $MB_ICONERROR, "Error", "There already exists a ""conf_plain.cfg"" here in this folder." & @CRLF & _
					"Please remove it first." )
				ContinueLoop
			EndIf

			If Not FileExists( @ScriptDir & "\ftool.exe" ) Then
				MsgBox( $MB_OK + $MB_ICONERROR, "Error", """ftool.exe"" was not found here in this folder." & @CRLF & _
					"Please move it here." )
				ContinueLoop
			EndIf

			$iFtoolPID = Run( @ScriptDir & '\ftool.exe -d "' & $sInputFilePath & '" conf_plain.cfg', @ScriptDir, @SW_HIDE, $STDOUT_CHILD )
			ProcessWaitClose( $iFtoolPID )
			Local $sFtoolOutput = StdoutRead( $iFtoolPID )
			;ConsoleWrite( $sFtoolOutput & @CRLF )

			If Not StringInStr( $sFtoolOutput, "SUID: " ) Then
				MsgBox( $MB_OK + $MB_ICONERROR, "Error", "ftool command line:" & @CRLF & _
					"'" & @ScriptDir & '\ftool.exe -d "' & $sInputFilePath & '" conf_plain.cfg' & "'" & @CRLF & @CRLF & _
					"ftool output:" & @CRLF & $sFtoolOutput )
				ContinueLoop
			EndIf

			$sSUID = StringRegExpReplace( $sFtoolOutput, '.*SUID: (.*) (.*).*', '$1 $2' )
			;ConsoleWrite( "'" & $sSUID & "'" & @CRLF )
			GUICtrlSetData( $cSUID, $sSUID )

			$hInputFile = FileOpen( @ScriptDir & "\conf_plain.cfg" )
			While True
				$sLine = FileReadLine( $hInputFile )
				If @ERROR Then
					MsgBox( $MB_OK + $MB_ICONERROR, "Error", "Something went wrong." & @CRLF & _
						"Could not determine serial number from ""conf_plain.cfg""." )
					ContinueLoop 2
				EndIf

				If StringInStr( $sLine, "# ID " ) Then
					ExitLoop
				EndIf
			WEnd
			FileClose( $hInputFile )

			$sSerialNumber = StringRegExpReplace( $sLine, '.*# ID (.*).*', '$1' )
			GUICtrlSetData( $cSerialNumber, $sSerialNumber )

			GUICtrlSetState( $cDecryptFile, $GUI_DISABLE )
			GUICtrlSetState( $cCreateNewFile, $GUI_ENABLE )



		Case $cCreateNewFile
			If Not FileExists( @ScriptDir & "\conf_template.cfg" ) Then
				MsgBox( $MB_OK + $MB_ICONERROR, "Error", """conf_template.cfg"" was not found here in this folder." & @CRLF & _
					"Please move it here." )
				ContinueLoop
			EndIf

			$hTemplateFile = FileOpen( @ScriptDir & "\conf_template.cfg" )
			$sTemplateFile = FileRead( $hTemplateFile )
			FileClose( $hTemplateFile )

			$sNewFile = StringReplace( $sTemplateFile, "xxxxxxxx", GUICtrlRead( $cSerialNumber ), 1, $STR_CASESENSE )

			If FileExists( @ScriptDir & "\conf_new.cfg" ) Then
				MsgBox( $MB_OK + $MB_ICONERROR, "Error", "There already exists a ""conf_new.cfg"" here in this folder." & @CRLF & _
					"Please remove it first." )
				ContinueLoop
			EndIf

			$hNewFile = FileOpen( @ScriptDir & "\conf_new.cfg", $FO_OVERWRITE )
			FileWrite( $hNewFile, $sNewFile )
			FileClose( $hNewFile )

			GUICtrlSetState( $cCreateNewFile, $GUI_DISABLE )
			GUICtrlSetState( $cCalcCRC03, $GUI_ENABLE )



		Case $cCalcCRC03
			If Not FileExists( @ScriptDir & "\CRC03.exe" ) Then
				MsgBox( $MB_OK + $MB_ICONERROR, "Error", """CRC03.exe"" was not found here in this folder." & @CRLF & _
					"Please move it here." )
				ContinueLoop
			EndIf

			$iCRC03PID = Run( @ScriptDir & "\CRC03.exe conf_new.cfg", @ScriptDir, @SW_HIDE, $STDOUT_CHILD )
			ProcessWaitClose( $iCRC03PID )
			Local $sCRC03Output = StdoutRead( $iCRC03PID )
			;ConsoleWrite( $sCRC03Output & @CRLF )

			$aCRC03Output = StringSplit( $sCRC03Output, @CRLF, 1 )
			$sCRC03Line = ""
			For $sLine In $aCRC03Output
				If StringInStr( $sLine, "# CRC03 " ) Then
					$sCRC03Line = $sLine
					ExitLoop
				EndIf
			Next

			$sCRC03 = StringRegExpReplace( $sCRC03Line, '.*# CRC03 (.*).*', '$1' )
			$sCRC03 = StringReplace( $sCRC03, @CR, "" )
			$sCRC03 = StringReplace( $sCRC03, @LF, "" )
			GUICtrlSetData( $cCRC03, $sCRC03 )
			;ConsoleWrite( "'" & $sCRC03 & "'" & @CRLF )

			GUICtrlSetState( $cCalcCRC03, $GUI_DISABLE )
			GUICtrlSetState( $cAddCRC03, $GUI_ENABLE )



		Case $cAddCRC03
			$hNewFile = FileOpen( @ScriptDir & "\conf_new.cfg", $FO_APPEND )
			FileWrite( $hNewFile, "# CRC03 " & GUICtrlRead( $cCRC03 ) & @CRLF )
			FileClose( $hNewFile )

			GUICtrlSetState( $cAddCRC03, $GUI_DISABLE )
			GUICtrlSetState( $cEncryptFile, $GUI_ENABLE )



		Case $cEncryptFile
			If FileExists( @ScriptDir & "\conf_new.cfc" ) Then
				MsgBox( $MB_OK + $MB_ICONERROR, "Error", "There already exists a ""conf_new.cfc"" here in this folder." & @CRLF & _
					"Please remove it first." )
				ContinueLoop
			EndIf

			$iFtoolPID = Run( @ScriptDir & "\ftool.exe -e conf_new.cfg conf_new.cfc " & GUICtrlRead( $cSUID ), @ScriptDir, @SW_HIDE, $STDOUT_CHILD )
			ProcessWaitClose( $iFtoolPID )
			Local $sFtoolOutput = StdoutRead( $iFtoolPID )
			;ConsoleWrite( "'" & $sFtoolOutput & "'" & @CRLF )

			If $sFtoolOutput <> "" Then
				MsgBox( $MB_OK + $MB_ICONERROR, "Error", "ftool command line:" & @CRLF & _
					"'" & @ScriptDir & "\ftool.exe -e conf_new.cfg conf_new.cfc " & GUICtrlRead( $cSUID ) & "'" & @CRLF & @CRLF & _
					"ftool output:" & @CRLF & $sFtoolOutput )
				ContinueLoop
			EndIf

			GUICtrlSetState( $cEncryptFile, $GUI_DISABLE )
			GUICtrlSetState( $cOpenExplorer, $GUI_ENABLE )



		Case $cOpenExplorer
			ShellExecute( 'explorer.exe', '/select,' & @ScriptDir & '\conf_new.cfc' )



		Case $GUI_EVENT_CLOSE
			ExitLoop
	EndSwitch
WEnd

GUIDelete()

Exit
